c --

       do i=3,n
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0
       ec(i)=parmas(ifl(i))
c   photons
       if(i1.eq.31)then
        ec(i)=eg
        c1(i)=cg
        c2(i)=cg
       endif
c   neutrinos
       if(i1.eq.1)then
          ptmissc=ptmiss
       endif
c   ch. leptons
       if(i1.eq.2)then
        ec(i)=max(el,ec(i))
        c1(i)=cl
        c2(i)=cl
       endif
c   quarks
       if(i1.eq.3.or.i1.eq.0)then
        ec(i)=max(eq,ec(i))
        c1(i)=cq
        c2(i)=cq
       endif
       enddo
    
       do i=3,n-1
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0
        do j=i+1,n
         if(ifl(j).lt.13)then
          j1=iabs(mod(ifl(j),4))
         else
          j1=ifl(j)
         endif
         if(j1.eq.35)j1=0
c  n-n
         if(i1.eq.1.or.j1.eq.1)then
c  l-q
         elseif(i1.eq.2.and.(j1.eq.3.or.j1.eq.0))then
         cc(i,j)=clq
c  l-l
         elseif(i1.eq.2.and.j1.eq.2)then
         cc(i,j)=cll
c  q-l
         elseif(j1.eq.2.and.(i1.eq.3.or.i1.eq.0))then
         cc(i,j)=clq
c  g-x  photon-charged
         elseif(i1.eq.31.and.j1.ne.1)then
         cc(i,j)=cgx
c  x-g  charged-photon
         elseif(j1.eq.31.and.i1.ne.1)then
         cc(i,j)=cgx
c  q-q
         elseif((i1.eq.3.or.i1.eq.0).and.
     .          (j1.eq.3.or.j1.eq.0))then
         cc(i,j)=cqq
         gmas(i,j)=gqq
c
         endif
        enddo
       enddo

       do l=4,20
        do k=3,l-1
         gmas(l,k)=gmas(k,l)
           cc(l,k)=  cc(k,l)
        enddo
       enddo

       print*,'---------------------------------------------------'
       print*,'        the cuts        '
       do i=3,n
       print*,'energy of  ',i,ifl(i),'   particle   ',ec(i)
       enddo
       do i=3,n
       print*,'cos-beam1 of ',i,ifl(i),'   particle   ',c1(i)
       enddo
       do i=3,n
       print*,'cos-beam2 of ',i,ifl(i),'   particle   ',c2(i)
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)
     .   print*,'cos of ',i,ifl(i),'  with  ',j,ifl(j),'  ',cc(i,j)
        enddo
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)
     .   print*,'mass of ',i,ifl(i),'  with  ',j,ifl(j),'  ',gmas(i,j)
        enddo
       enddo
       print*,'minimum missing transverse momentum',ptmissc
       print*,'---------------------------------------------------'

       return
       end
      
       subroutine cuts(icut)
       include 'declare.h'
       
       include 'common_int.h'
       include 'common_phegas_mom.h'
       include 'common_cuts.h'
       
       icut=0
       
       do l=3,n 
       if(pmom(l,4).lt.ec(l))return
       c=pmom(l,3)/pmom(l,4)
       if( c.gt.c1(l))return
       if(-c.gt.c2(l))return
       enddo
       
       do l1=3,n
        do l2=3,n
         if(l1.eq.l2)cycle
         if(cosij(pmom(l1,1:3),pmom(l2,1:3)).gt.cc(l1,l2))return
         s=2*scalar_product(pmom(l1,1:4),pmom(l2,1:4))
     .    +scalar_product(pmom(l1,1:4),pmom(l1,1:4))
     .    +scalar_product(pmom(l2,1:4),pmom(l2,1:4))
         if(s.lt.gmas(l1,l2)**2)return
        enddo
       enddo

       i_nu=0
       pmiss_E=0.d0
       pmiss_x=0.d0
       pmiss_y=0.d0
       pmiss_z=0.d0
       do l=3,n
          if(iabs(ifl(l1)).eq.1.OR.iabs(ifl(l1)).eq.5.OR.
     .       iabs(ifl(l1)).eq.9) then !neutrino found
           
             i_nu=1
             pmiss_E = pmiss_E + pmom(l,4)
             pmiss_x = pmiss_x + pmom(l,1)
             pmiss_y = pmiss_y + pmom(l,2)
             pmiss_z = pmiss_z + pmom(l,3)
          endif
       enddo
       pt_miss=sqrt((pmiss_x)**2+(pmiss_y)**2)
       if(i_nu.eq.1 .and. pt_miss.lt.ptmissc)return

       icut=1
       
       return
       end

